VERSION 5.00
Begin VB.UserControl httpUC 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.TextBox T1 
      Height          =   315
      Left            =   300
      TabIndex        =   0
      Top             =   720
      Width           =   1695
   End
End
Attribute VB_Name = "httpUC"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

 '-- httpUC. File download UserControl using Winsock 1.1
 '-- Designed to work in all Windows versions with only VB6 runtime dependency.
 
Private Const WM_LBUTTONUP = &H202
Private Const cSLASH As String = "/"
Private Const LEN8192 As Long = 8192
Private Const cSPACE = " "
Private Const cRETURN2 = vbCrLf & vbCrLf

Private Const SOCKET_ERROR = -1
Private Const INADDR_NONE = &HFFFFFFFF
Private Const WSAEWOULDBLOCK = 10035
Private Const WSADESCRIPTION_LEN = 256
Private Const WSASYS_STATUS_LEN = 128

'--Error codes:
Private Const WSABASEERR = 10000
  '-- init errors:
Private Const WSASYSNOTREADY = (WSABASEERR + 91)
Private Const WSAVERNOTSUPPORTED = (WSABASEERR + 92)
Private Const WSAEFAULT = (WSABASEERR + 14)
Private Const WSAEPROCLIM = (WSABASEERR + 67)
Private Const WSAEINPROGRESS = (WSABASEERR + 36)
Private Const WSAEMSGSIZE = WSABASEERR + 40

' wininet:
Private Const INTERNET_CONNECTION_PROXY As Long = &H4

Private Const AF_INET = 2        ' internetwork: UDP, TCP, etc.
Private Const SOCK_STREAM = 1

'-- constants for receive loop message type:
Private Const FD_READ = &H1&
Private Const FD_CLOSE = &H20&

Private Type WSAData
    wVersion As Integer
    wHighVersion As Integer
    szDescription(0 To WSADESCRIPTION_LEN) As Byte
    szSystemStatus(0 To WSASYS_STATUS_LEN) As Byte
    iMaxSockets As Integer
    iMaxUdpDg As Integer
    lpVendorInfo As Long
End Type

Private Type sockaddr
    sin_family As Integer
    sin_port As Integer
    sin_addr As Long
    sin_zero As String * 8
End Type

Private Type HostEnt
    h_name As Long
    h_aliases As Long
    h_addrtype As Integer
    h_length As Integer
    h_addr_list As Long
End Type

'------------------------------------------------------
 
 '-- winsock.
Private Declare Function WSAStartup Lib "wsock32.dll" (ByVal wVR As Long, lpWSAD As WSAData) As Long
Private Declare Function WSAAsyncSelect Lib "wsock32.dll" (ByVal s As Long, ByVal hwnd As Long, ByVal wMsg As Long, ByVal lEvent As Long) As Long
Private Declare Function WCreateSocket Lib "wsock32.dll" Alias "socket" (ByVal af As Long, ByVal s_type As Long, ByVal protocol As Long) As Long
Private Declare Function WConnect Lib "wsock32.dll" Alias "connect" (ByVal s As Long, addr As sockaddr, ByVal namelen As Long) As Long
Private Declare Function WSend Lib "wsock32.dll" Alias "send" (ByVal s As Long, buf As Any, ByVal buflen As Long, ByVal flags As Long) As Long
Private Declare Function WReceive Lib "wsock32.dll" Alias "recv" (ByVal s As Long, buf As Any, ByVal buflen As Long, ByVal flags As Long) As Long
Private Declare Function WCloseSocket Lib "wsock32.dll" Alias "closesocket" (ByVal s As Long) As Long
Private Declare Function WSACleanup Lib "wsock32.dll" () As Long
Private Declare Function htons Lib "wsock32.dll" (ByVal hostshort As Long) As Integer
Private Declare Function gethostbyname Lib "wsock32.dll" (ByVal host_name As String) As Long
   '-- wininet.
Private Declare Function InternetGetConnectedState Lib "wininet" (ByRef dwflags As Long, ByVal dwReserved As Long) As Long
   '-- general usage.
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (xDest As Any, xSource As Any, ByVal nbytes As Long)
Private Declare Function DeleteFile Lib "kernel32" Alias "DeleteFileA" (ByVal lpFileName As String) As Long


'----------------------------------------------------------------------------
'-- >>> NOTE: I was working on 2 projects at once with this control.
'-- I think that I sorted out the differences and this should work
'-- without errors, but if a wrongly-named variable or routine turns up
'-- that's the reason.
'
'------------------------------------------------------------------------

' ---- Events ---------
' OnConnect(sURL)  '-- occurs with successful server connection. sURL is server URL.
'
' OnDownloadFinish(LErrCode, sErrStr) '-- occurs when download complete, whether successful or not.
    '-- Result:
     '  If technical problem: LErrCode = -1.  sErrStr = error string.
     '  If server response:
     '      LErrCode = server code. (ex.: 200)
     '      sErrStr =  server response code. (ex.: "OK")
     '
     ' LErrCode is the standard server response code returned with requests.
     ' In general sErrStr will just return the error string. (ex.: 404, "File not Found" )
     ' The exception is with errors 301-303. Those error indicate the file has
     ' been moved and the Location header in the server response provides
     ' the new URL. So with those errors the Location header is also returned
     ' in sErrStr so that the new URL can be retrieved.
 '
' OnDisconnect() - occurs when connection to server is broken.

'---- Properties --------------------------
 
'  Port -        Long. Write only. Port number to connect with. Defaults to 80.
'  IsOnline - Boolean.
'  IsConnectionProxy - Boolean.
'  ServerCode - Long. example: 200
'  ServerString - string. example: "OK"
'  UserAgent - string. defaults to: "YOUR NAME HERE"
'
'[The following are for use only after OnDownloadFinish event.]
'   CurSize - long. size in bytes of current file.
'   CurFileString - string. returns downloaded file as string. (for ASCII files.)
'   CurFileBytes - Collection. returns a collection of arrays containing file bytes.
'
'---- Metohds -----------------------------
'
'  LRet = StartUp(sErrorString)  '-- start winsock. return:  0-success.
'      1-System not ready for network communication.
'      2-Winsock version 1.1 not supported.
'      3-A blocking winsock is already in use.
'      4-The limit on number of winsock tasks has been reached.
'      5-Error with parameter of WSAStartup call.
'      6- Unknown error.
'
'  LRet = RequestFile(sServer as String, sFile as String)
'--     ex.: Ret = RequestFile("www.somewhere.com", "/index.html")
'    '-- requests a file from server.
     '-- returns 0 on success.
     '-- errors return error string in sFile variable and error code in LRet.
     '--     ' 99  SendData failed to send server request.
             ' 106 No Internet connection active.
             ' 107 Internet connection is via proxy server.
             ' 109 Winsock error - Failed to create socket. Error number:
             ' 110 Winsock error - Failed to connect to server. Error number:
             ' 111 Winsock err - Failure with WSAAsyncSelect. Error number:
             ' 112 Failed to resolve server IP address.
             ' 113 No server string sent.
             ' 114 No file path sent.
 '
 '  LRet = WriteTextFile(sPath as String, IfDelete as Boolean)
 '  LRet = WriteBinaryFile(sPath, IfDelete)
 '      These two functions write a text or binary file from downloaded
 '   bytes. sPath is path of file. IfDelete is whether to delete an existing
 '   file.
 '  return: 0-success. 1-file exists (IfDelete = False). 2-no bytes to write.
 '          3-no current file.
 '
 '-- Sub CloseDown() '-- close any open socket. recommended but not required.
'===================================================================
'
Public Event OnConnect(sURL)
Public Event OnDownloadFinish(LErrCode As Long, sErrStr As String)
Public Event OnDisconnect()
'
'------------------------------------------------------------------------------
Private HSock As Long  '--socket handle.
Private SockValue As Long '--  will be 100 if winsock started.
Private iErrCode As Long        '-- holds last error string index.
Private BooHooked As Boolean  '-- whether callback is engaged.
Private TPPixX As Long        '-- get twips-per-pixel-x at startup to avoid repeated lookup.
Private FirstRead As Boolean '-- get server error code on first data read.
Private LServerCode As Long  '-- current server response code for this file download attempt.
Private sServerCode As String '-- error code info. string.
Private LPortNumber As Long  '-- port.
Private UAgent As String     '--user agent.
Private ObFile As Collection '-- collection to hold file bytes.
Private LSize As Long        '-- size of current file.
'--
'--=========================================================

   '-- port. defaults to 80.
Public Property Let Port(LPort1 As Long)
    LPortNumber = LPort1
End Property

   '-- Server response code. ex.: 200
Public Property Get ServerCode() As Long
  ServerCode = LServerCode
End Property
  
   '-- set userAgent string.
Public Property Let UserAgent(sAgent As String)
  UAgent = sAgent
End Property
 
   '-- server response code string. ex.: if code is 200 then string is "OK".
Public Property Get ServerString() As String
  ServerString = sServerCode
End Property

   '-- Is there currently an online connection?
Public Property Get IsOnline() As Boolean
  Dim LFlags As Long
    On Error Resume Next
  IsOnline = InternetGetConnectedState(LFlags, 0&)
End Property

   '-- Is the online connection through a proxy?
Public Property Get IsConnectionProxy() As Boolean
    Dim LFlags As Long, LRet As Long
        On Error Resume Next
   LRet = InternetGetConnectedState(LFlags, 0&)
   IsConnectionProxy = LFlags And INTERNET_CONNECTION_PROXY
End Property

  '-- Initialize Winsock.
Public Function StartUp(sErr As String) As Long '--returns 0 if OK.
  Dim sRet As String
    '-- initialize Winsock with startup call.
  iErrCode = 0
  SockValue = StartWinsock()
   If (iErrCode <> 0) Then
      sErr = LoadResString(iErrCode)
   End If
  StartUp = iErrCode
End Function
  '-- request file from server. returns 0 on successfully connecting and sending request.
Public Function RequestFile(sServer1 As String, sFile1 As String) As Long
  Dim LRet As Long
  Dim sRet As String
  Dim Boo1 As Boolean
       On Error Resume Next
       
    ResetOps  '-- reset variables for new file operation.
   
     If Len(sServer1) = 0 Then
        sFile1 = LoadResString(113) '-- no server string.
        RequestFile = 113
        Exit Function
     End If
    
    If Len(sFile1) = 0 Then
       sFile1 = LoadResString(114) '-- no file path string.
       RequestFile = 114
       Exit Function
    End If
    
  If (Left$(sServer1, 7) = "http://") Then sServer1 = Right$(sServer1, (Len(sServer1) - 7))
  If (Left$(sServer1, 6) = "ftp://") Then sServer1 = Right$(sServer1, (Len(sServer1) - 6))
  If (Left$(sFile1, 1) <> cSLASH) Then sFile1 = cSLASH & sFile1
  
    '-- Connect. Return error string if failed.
  LRet = ConnectServer(sServer1, sRet)
    If (LRet <> 100) Then
       sFile1 = sRet
       RequestFile = LRet
       Exit Function
    End If
    
  Boo1 = SendRequest(sServer1, sFile1, sRet)
    If (Boo1 = False) Then
      sFile1 = sRet
      RequestFile = 99  '-- SendData failed.
    End If
      
   RequestFile = 0
End Function

'-- return file. Use this after OnDownloadFinish event if iErrCode = 0 and sErrStr = "200"
Public Property Get CurFileString() As String
  Dim s2 As String, s3 As String
    On Error Resume Next
   CurFileString = ""
     If (IsObject(ObFile) = False) Then Exit Property
     If (LSize = 0) Then Exit Property
   CurFileString = GetString()
End Property

 '-- return file bytes as collection of byte arrays.
Public Property Get CurFileBytes() As Collection
  On Error Resume Next
    If (IsObject(ObFile) = False) Then Exit Property
  Set CurFileBytes = ObFile
End Property

Public Property Get CurSize() As Long
  On Error Resume Next
   CurSize = 0
      If (IsObject(ObFile) = False) Then Exit Property
   CurSize = LSize
End Property

  '-- write text file. 0-success. 1-file exists. 2-no bytes. 3-no current downloaded file.
Public Function WriteTextFile(sPath As String, IfDelete As Boolean) As Long
  Dim LRet As Long
     On Error Resume Next
   If (IsObject(ObFile) = False) Then
     WriteTextFile = 3
     Exit Function
   End If
     LRet = WriteFileS(sPath, IfDelete)
    WriteTextFile = LRet
End Function

 '-- write binary file. 0-success. 1-file exists. 2-no bytes. 3-no current downloaded file.
Public Function WriteBinaryFile(sPath As String, IfDelete As Boolean) As Long
  Dim LRet As Long
     On Error Resume Next
   If (IsObject(ObFile) = False) Then
     WriteBinaryFile = 3
     Exit Function
   End If
     LRet = WriteFileB(sPath, IfDelete)
    WriteBinaryFile = LRet
End Function

Public Sub CloseDown() '-- close socket.
   CloseDownPriv
End Sub

'--#######################################################################
'--##############    PRIVATE    ##########################################

'_______________  Misc. Functions ______________________________________

'-- File bytes handling: AddArray. GetString. WriteFileS. WriteFileB.
'-- general: FileExisits. DeleteFile.
'_______________________________________________________________________

'-- Add an array of file bytes. to collection object.
Private Sub AddArray(AIn As Variant)
  On Error Resume Next
'    If (IsObject(ObFile) = False) Then
'       Set ObFile = New Collection
'    End If
  ObFile.Add AIn
  LSize = LSize + UBound(AIn) + 1
End Sub

  '-- return file as single string.
Private Function GetString() As String
 Dim LCnt As Long, i2 As Long, LUb As Long
 Dim A1() As String
 Dim A2 As Variant
 Dim s1 As String

  On Error Resume Next
    If (LSize = 0) Then GoTo Woops
   LCnt = ObFile.Count
    If (LCnt = 0) Then GoTo Woops
       
  ReDim A1(LCnt - 1) As String
    For i2 = 1 To LCnt
      s1 = StrConv(ObFile.Item(i2), vbUnicode)
    A1(i2 - 1) = s1
  Next
  
  s1 = Join(A1, "")
  GetString = Replace(s1, vbLf, vbCrLf)
    Exit Function
Woops:
  GetString = ""
End Function

Private Function WriteFileS(sPath As String, IfDelete As Boolean) As Long
  Dim LCnt As Long, LTot As Long, i2 As Long
  Dim FF As Integer
  Dim A1 As Variant
  Dim sAll As String
    On Error Resume Next
    
   If (jsFileExists(sPath) = True) Then
      If (IfDelete = False) Then
         WriteFileS = 1  '-- file exists.
         Exit Function
      Else  '-- delete it.
         DeleteFile sPath
      End If
   End If
    LCnt = ObFile.Count
    
   If (LCnt = 0) Or (LSize = 0) Then
      WriteFileS = 2  '-- no bytes.
      Exit Function
   End If
   
     sAll = GetString
    
      FF = FreeFile()
    Open sPath For Output As #FF
       Print #FF, sAll;
    Close #FF
  WriteFileS = 0
End Function

Private Function WriteFileB(sPath As String, IfDelete As Boolean) As Long
  Dim LCnt As Long, LTot As Long, i2 As Long
  Dim FF As Integer
  Dim A1() As Byte
  Dim sAll As String
    On Error Resume Next
    
   If (jsFileExists(sPath) = True) Then
      If (IfDelete = False) Then
         WriteFileB = 1  '-- file exists.
         Exit Function
      Else  '-- delete it.
         DeleteFile sPath
      End If
   End If
    LCnt = ObFile.Count
    
   If (LCnt = 0) Or (LSize = 0) Then
      WriteFileB = 2  '-- no bytes.
      Exit Function
   End If
   
   FF = FreeFile()
    Open sPath For Binary As #FF
      For i2 = 1 To LCnt
        A1 = ObFile.Item(i2)
        Put #FF, , A1
      Next
    Close
      WriteFileB = 0
End Function

Private Function jsFileExists(ByVal sPath As String) As Boolean
  Dim i As Integer
  On Error Resume Next
 Err.Clear
   jsFileExists = False
   i = GetAttr(sPath)
     If (Err = 0) Then
        If (i And vbDirectory) = 0 Then
            jsFileExists = True
        End If
     End If
    Err.Clear
End Function

Private Sub jsDeleteFile(sDeletePath As String)
  '--delete a file. --------------------------
  Dim i As Integer
  Dim LDel As Long
  On Error Resume Next
   Err.Clear
   i = GetAttr(sDeletePath)
   If (Err.Number <> 0) Then Exit Sub
   SetAttr sDeletePath, 0
   LDel = DeleteFile(sDeletePath)
End Sub

'=====================================================================
'=================== COMMUNICATION FUNCTIONS =========================
'_________________________________________________________________________

'   StartWinsock  (initializes winsock.)
'   ResolveServer (translates server URL.)
'   ConnectServer (creates new socket and connects to server.)
'   T1_MouseUp    (callback function to receive data from server async.
'   SendRequest   (sends request for file to server.)
'   SendData      (method to send data to server.)
'   Disconnect    (disconnects from server.)
'_________________________________________________________________________
'=====================================================================

  '-- connect to server. returns 100 on success. Otherwise error string is in sErr.
Private Function ConnectServer(sServerURL As String, sErr As String) As Long
 Dim LRet As Long, LEvents As Long, iVal As Long
 Dim sck As sockaddr
     On Error Resume Next
    sErr = ""
   '------------- online? --------------------------------
      If (IsOnline = False) Then
         iVal = 106  '-- No Internet connection available.
         GoTo QuitError
      End If
   '-------------proxy? ----------------------
      If (IsConnectionProxy = True) Then
          iVal = 107  '-- Internet connection is via proxy server.
          GoTo QuitError
      End If
   '------------- server string missing? ----------------------
    If (Len(sServerURL) = 0) Then
      iVal = 113  '-- no server string.
       GoTo QuitError
    End If
 
    '-- create a new socket:
   HSock = WCreateSocket(AF_INET, SOCK_STREAM, 0&)
    If (HSock = -1) Then
       iVal = 109
       GoTo QuitError   ' Winsock error: Failed to create socket.
    End If
    
    With sck
       .sin_family = AF_INET
       .sin_addr = ResolveServer(sServerURL)
       .sin_port = htons(LPortNumber)
       .sin_zero = String$(8, 0)
    End With
    
    If (sck.sin_addr = INADDR_NONE) Then
        LRet = WCloseSocket(HSock)
         HSock = 0
         iVal = 112   ' Failed to resolve server IP address.
         GoTo QuitError
      End If
   '------- try to connect: -----------------------------
        Err.Clear
    LRet = WConnect(HSock, sck, Len(sck))
      If (LRet <> 0) Then  '-- was if = -1
         LRet = WCloseSocket(HSock)
         HSock = 0
         iVal = 110  ' Failed to connect.
         GoTo QuitError
      End If
        
      Err.Clear
        
  '-------- set hook for callback -----------------------
      LEvents = FD_READ Or FD_CLOSE
    LRet = WSAAsyncSelect(HSock, T1.hwnd, WM_LBUTTONUP, LEvents)
       If (LRet = -1) Then
           LRet = WCloseSocket(HSock)
           HSock = 0
           iVal = 111     ' failed with WSAAsyncSelect function.
           GoTo QuitError
       End If
       
          BooHooked = True
          iErrCode = 0
          ConnectServer = 100
          RaiseEvent OnConnect(sServerURL)
   Exit Function
QuitError:
   sErr = LoadResString(iVal)
    If (iVal > 108) And (iVal < 112) Then  '--winsock errors.
      sErr = sErr & CStr(Err.LastDllError)
    End If
   ConnectServer = iVal
  
End Function

Private Function ResolveServer(sServ As String) As Long
    On Error Resume Next
    Dim LRet As Long, LRet2 As Long
    Dim HEnt As HostEnt
    Dim LAddrList As Long
   
      LRet2 = gethostbyname(ByVal sServ)
           If (LRet2 > 0) Then
              CopyMemory HEnt, ByVal LRet2, Len(HEnt)
              CopyMemory LAddrList, ByVal HEnt.h_addr_list, 4
              CopyMemory LRet, ByVal LAddrList, HEnt.h_length
           Else
              LRet = INADDR_NONE
           End If
    
    ResolveServer = LRet
End Function

Private Function SendRequest(sServ2 As String, sFile As String, sRet As String) As Boolean
 Dim sMsg As String, sRet1 As String
 Dim LRet As Long
   On Error Resume Next
   sMsg = "GET " & sFile & " HTTP/1.0" & vbCrLf
   sMsg = sMsg & "User-Agent: " & UAgent & vbCrLf
   sMsg = sMsg & "Host: " & sServ2 & vbCrLf & vbCrLf
        LRet = SendData(sMsg, sRet1)
      If (LRet <> 0) Then
        sRet = sRet1
        SendRequest = False
      Else
        SendRequest = True
      End If
End Function

'-- Start up winsock.
Private Function StartWinsock() As Long  '--return 100 if success.
 Dim LRet As Long
 Dim WData As WSAData  'structure to pass to WSAStartup as an argument
   On Error Resume Next
     If (SockValue = 100) Then '-- already started. make sure it stays 100.
       StartWinsock = 100
       Exit Function
     End If
   LRet = WSAStartup(&H101, WData)
      If (LRet <> 0) Then
          Select Case LRet
              Case WSASYSNOTREADY
                 iErrCode = 101  ' "System not ready for network communication."
                 StartWinsock = 1  ' system not ready for network communication.
              Case WSAVERNOTSUPPORTED
                 iErrCode = 102  '"Winsock version 1.1 not supported."
                 StartWinsock = 2  ' version 1.1 not supported.
              Case WSAEINPROGRESS
                 iErrCode = 103  ' "A blocking winsock is already in use."
                 StartWinsock = 3  ' a blocking winsock already in use.
              Case WSAEPROCLIM
                 iErrCode = 104   ' "The limit on number of winsock tasks has been reached."
                 StartWinsock = 4  ' limit on number of winsock tasks has been reached.
              Case WSAEFAULT
                 iErrCode = 105 '  "Error with parameter of WSAStartup call."
                 StartWinsock = 5  '  WData is not a valid pointer.
              Case Else
                 iErrCode = 115  ' Unknown error.
                 StartWinsock = 6
            End Select
     Else
       StartWinsock = 100
     End If
End Function

'-- disconnect socket.
Private Sub DisConnect()
 Dim LRet As Long
  On Error Resume Next
   If (HSock > 0) Then
       If (BooHooked = True) Then
           LRet = WSAAsyncSelect(HSock, T1.hwnd, 0&, 0&)
           BooHooked = False
       End If
     LRet = WCloseSocket(HSock)
     HSock = 0
     RaiseEvent OnDisconnect
   End If
   
End Sub

Private Function SendData(sData As String, sErr As String) As Long
  Dim LRet As Long, LenDat As Long
  Dim AData() As Byte
      On Error Resume Next
   SendData = 0
   LenDat = Len(sData)
      If (LenDat > 0) Then
        AData() = StrConv(sData, vbFromUnicode)
        LRet = WSend(HSock, AData(0), LenDat, 0&)
          If (LRet = -1) Then
              If Not (Err.LastDllError = WSAEWOULDBLOCK) Then
                  sErr = CStr(Err.LastDllError)
                  SendData = -1
              End If
          End If
      End If
        
End Function

Private Sub T1_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Dim sBuf As String
  Dim ABuf() As Byte
  Dim AByte() As Byte
  Dim LNum As Long, LMsg As Long, HeadLen As Long, LUb As Long
 
    On Error Resume Next
      '-- Callback event code is Loword of lParam, which matches mouse X except that
      '-- VB will have converted that to twips. So to use this as a SendMessage-type
      '-- operation just divide X by Screen.TwipsPerPixelX to get mesage number!
       
 If (X > 0) Then
    LMsg = CLng(X \ TPPixX)  '-- Get FD_xxxx code.
     Select Case LMsg
     
        Case FD_READ '--  &H1   - read buffer is ready. Get <= 8 KB.
           ReDim ABuf(0 To 8191) As Byte
           LNum = WReceive(HSock, ABuf(0), LEN8192, 0&)
            If (LNum > 0) Then   '-- 0-closed. -1-error.
                If (LNum < 8192) Then
                  ReDim Preserve ABuf(0 To (LNum - 1)) As Byte
                End If
                 '------- get server code and adjust array on first read. ------------
                 If (FirstRead = True) And (LNum > 50) Then
                     FirstRead = False
                     sBuf = StrConv(ABuf(), vbUnicode) '-- convert 1st array to string.
                     HeadLen = GetServerStrings(sBuf)  '-- get server strings and len of header.
                     LUb = (UBound(ABuf) - HeadLen) '-- rebuild array to remove header.
                     ReDim AByte(0 To LUb) As Byte
                    For LNum = 0 To LUb
                         AByte(LNum) = ABuf(LNum + HeadLen)
                    Next
                      AddArray AByte   '-- add array to collection.
                 
                 Else
                     AddArray ABuf   '-- add array to collection.
                End If
             Else  '-- recv returned 0 (all bytes received) or -1 (error).
                DisConnect
                 If (LNum = -1) Then
                    RaiseEvent OnDownloadFinish(-1, CStr(Err.LastDllError))
                 Else
                    RaiseEvent OnDownloadFinish(LServerCode, sServerCode)
                 End If
             End If
             
         Case FD_CLOSE  '-- &H20 - server socket closing. Get whatever is left in buffer.
         
            Do
              ReDim ABuf(0 To 8191) As Byte
              LNum = WReceive(HSock, ABuf(0), LEN8192, 0&)
                If LNum > 0 Then
                   If (LNum < 8192) Then
                       ReDim Preserve ABuf(0 To (LNum - 1)) As Byte
                   End If
                     AddArray ABuf
                End If
            Loop Until LNum < 1  '--  0 Or -1 SOCKET_ERROR
              DisConnect
             If (LNum = -1) Then
               RaiseEvent OnDownloadFinish(-1, CStr(Err.LastDllError))
             Else
               RaiseEvent OnDownloadFinish(LServerCode, sServerCode)
             End If
             
         Case Else
           '--
      End Select
  End If
End Sub

  '-- get header for server error codes from first data arrival.
  '-- also remove header from first data array.
Private Function GetServerStrings(sBuf1 As String) As Long
 Dim Pt1 As Long, Pt2 As Long, i2 As Long, HeadLen As Long
 Dim s3 As String, sCode As String, sBuf As String
 Dim AByte() As Byte
      On Error Resume Next
   Pt1 = InStr(1, sBuf1, cRETURN2)
     If (Pt1 > 0) Then
       HeadLen = Pt1 + 3  '-- get header length for return.
       '-- parse out error code and string.
       '-- first line from server is like: "HTTP1.1 200 OK"
         Pt2 = InStr(1, sBuf1, vbCrLf)
         s3 = Left$(sBuf1, Pt2)
         Pt1 = InStr(1, s3, cSPACE)
           If (Pt1 > 0) Then
             sCode = Mid$(s3, (Pt1 + 1), 3)  '-- 3-place server code.
               If IsNumeric(sCode) Then LServerCode = CLng(sCode)
              sServerCode = Right$(s3, (Len(s3) - (Pt1 + 4)))
              sServerCode = Left$(sServerCode, (Len(sServerCode) - 1))
              
                '-- Also get Location header line if file has moved.
                '-- That will be a line in server header that reads: "Location: <URL>"
               If (LServerCode > 300) And (LServerCode < 304) Then
                  sCode = Left$(sBuf1, HeadLen)
                  Pt1 = InStr(1, sCode, "Location:", 1)
                  If (Pt1 > 0) Then
                    Pt2 = InStr(Pt1, sCode, vbCrLf, 1)
                      If (Pt2 > 0) Then
                          '-- add the location line of redirect to error code:
                         sServerCode = sServerCode & Mid$(sCode, Pt1, (Pt2 - Pt1))
                      End If
                  End If
               End If
           End If
      End If
        GetServerStrings = HeadLen
End Function


'====================================================================
'====================== BASIC =======================================
'____________________________________________________________________
  
' ResetOps  (resets variables for next file.)
' Intialize and Terminate (UC Ops.)
' CloseDownPriv  (close Winsock.)
Private Sub ResetOps()
  iErrCode = 0
  FirstRead = True
  LSize = 0
  LServerCode = 0
  sServerCode = ""
  Set ObFile = Nothing
  Set ObFile = New Collection
End Sub

Private Sub UserControl_Initialize()
  TPPixX = Screen.TwipsPerPixelX
  LPortNumber = 80
  UAgent = "YOUR NAME HERE"
  ResetOps
End Sub

Private Sub UserControl_Terminate()
   On Error Resume Next
   CloseDownPriv
End Sub

Private Sub CloseDownPriv()
  Dim LRet As Long
   On Error Resume Next
 If (HSock > 0) Then
      DisConnect
  End If
  If (SockValue = 100) Then
      LRet = WSACleanup()
      SockValue = 0
  End If
End Sub

'-- ////////////////////////////////////////////////////
'-- Strings that can go in the program RES file or be dealt with in some other way:

' 101 System not ready for network communication.
' 102 Winsock version 1.1 not supported.
' 103 The limit on number of winsock tasks has been reached.
' 104 The limit on number of winsock tasks has been reached.
' 105 Error with parameter of WSAStartup call.
' 106 No Internet connection active.
' 107 Internet connection is via proxy server.
'------ 108 Server address string missing.
' 109 Winsock error - Failed to create socket. Error number:
' 112 Failed to resolve server IP address.
' 110  Winsock error - Failed to connect to server. Error number:
' 111  Winsock err - Failure with WSAAsyncSelect. Error number:
' 113  Server string is empty.
' 114  URL string is empty.


